/*
** MACROs
*/


@#define number_of_observables = 8
@#define ObservablesNames = ["dY"] + ["dC"] + ["dW"] + ["TUC"] + ["dI"] + ["HICP_GA"] + ["LoggedR"] + ["Lobs"] + ["dG"] + ["LoggedPI"]

@#define efficient_block = 1
@#define NumberOfShocks  = 0
@#define ar_variance_decrease  = "1.0"

@#define ExogenousVariables_vnames = ["ProductionEfficiencyGrowth"]
@#define ExogenousVariables_inames = ["EfficiencyGrowthInnovation"]
@#define ExogenousVariables_pnames = ["production_efficiency_growth"]
@#define ExogenousVariables_nblags = [1]
@#define ExogenousVariables_acorr1 = [".4635"]
@#define ExogenousVariables_vtexnames = ["A_T"]
@#define ExogenousVariables_sstexnames = ["\overline A_T"]
@#define NumberOfShocks  = NumberOfShocks + 1 


@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["ProductionEfficiencyCycle"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["EfficiencyCycleInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["production_efficiency"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".50"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["A_C"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\overline A_C"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["ConsumptionTax"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["ConsumptionTaxInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["consumption_tax"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".9102"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\tau_C"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar \tau_C"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["LabourIncomeTax"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["LabourIncomeTaxInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["labour_income_tax"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".9577"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\tau_W"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar \tau_W"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["IncomeTax"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["IncomeTaxInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["income_tax"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + ["0.9092"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\tau_R"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar \tau_R"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["RiskPremium"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["RiskPremiumInnovation"]
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["risk_premium"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".50000"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\varepsilon_B"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar\varepsilon_B"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["LabourSupplyShock"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["LabourSupplyInnovation"]
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["labour_supply"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".50000"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\varepsilon_L"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\widetilde L"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["InvestmentRelativePrice"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["InvestmentRelativePriceInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["investment_relative_price"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + ["0.9180"]
//@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + ["0"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["p_I"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar p_I"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["InvestmentEfficiencyShock"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["InvestmentEfficiencyInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["investment_efficiency"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".50000"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\varepsilon_I"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar\varepsilon_I"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["LabourTax"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["LabourTaxInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["labour_tax"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".7504"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\tau_L"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar\tau_L"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["PriceMarkUpShock"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["PriceMarkUpInnovation"]
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["price_mark_up"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".50000"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\varepsilon_y"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar\varepsilon_y"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["WageMarkUpShock"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["WageMarkUpInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["wage_mark_up"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".50000"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\varepsilon_l"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar\varepsilon_l"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["InflationTarget"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["InflationTargetInnovation"]
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["inflation_target"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".5000"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\bar\pi"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar\pi"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["TaylorShock"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["TaylorInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["taylor"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + [".5000"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\varepsilon_R"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar\varepsilon_R"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["PublicSpendingShare"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["PublicSpendingShareInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["public_spending"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + ["0.8545"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\varepsilon_g"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar\varepsilon g"]
@#define NumberOfShocks  = NumberOfShocks + 1

@#define ExogenousVariables_vnames = ExogenousVariables_vnames + ["FoodAndEnergyPrices"]
@#define ExogenousVariables_inames = ExogenousVariables_inames + ["FoodAndEnergyPricesInnovation"] 
@#define ExogenousVariables_pnames = ExogenousVariables_pnames + ["volatile_prices"]
@#define ExogenousVariables_nblags = ExogenousVariables_nblags + [1]
@#define ExogenousVariables_acorr1 = ExogenousVariables_acorr1 + ["0.8545"]
@#define ExogenousVariables_vtexnames = ExogenousVariables_vtexnames + ["\tilde \pi"]
@#define ExogenousVariables_sstexnames = ExogenousVariables_sstexnames + ["\bar \tilde \pi"]
@#define NumberOfShocks  = NumberOfShocks + 1

// AutoregressiveProcesses(i,1)  [string]  Name of the variable.
// AutoregressiveProcesses(i,2)  [string]  Generic name of the autoregressive parameters
// AutoregressiveProcesses(i,3)  [integer] Number of lags.

global AutoregressiveProcesses; % Needed in the steady state file, where we have to update parameters related to the exogenous variables.
AutoregressiveProcesses = cell(@{NumberOfShocks},3);
@#for shock in 1:NumberOfShocks
  AutoregressiveProcesses(@{shock},1) = {'@{ExogenousVariables_vnames[shock]}'} ;
  AutoregressiveProcesses(@{shock},2) = {'@{ExogenousVariables_pnames[shock]}'} ;
  AutoregressiveProcesses(@{shock},3) = { @{ExogenousVariables_nblags[shock]} } ;
@#endfor


// Welfare evaluation:
@#define UtilityFlow = "((Consumption-eta*Consumption(-1)/ProductionEfficiencyGrowth)^(1-sigmac))/(1-sigmac)*exp(LabourSupplyShock*(sigmac-1)/(1+sigmal)*(HouseholdLabourSupply/household_labour_supply_ss)^(1+sigmal))"
@#define CounterFactualUtilityFlow = "((CounterFactualConsumption*(1-eta/(1+production_efficiency_growth_ss)))^(1-sigmac))/(1-sigmac)*exp(labour_supply_ss*(sigmac-1)/(1+sigmal))"

/*
** MOD FILE CORE
*/

/* 84 Endogenous variables (if efficient_block is equal to 1) */ 
var
    /* Households */
    Consumption
    HouseholdLabourSupply
    HouseholdLagrangeMultiplier
    Investment
    CapitalStock
    DepreciationRate
    dDepreciationRate
    InvestmentCost
    dInvestmentCost
    CapacityUtilizationFactor
    CapitalReturnRate
    HouseholdRealWage
    TobinQ
    /* Prices */
    RealGrossWage
    LabourDemand
    CapitalDemand
    RealMarginalCost
    OptimalRelativePrice
    Z1
    Z2
    Z3
    GDP
    FinalGoodLagrangeMultiplier
    NonOptimizingFirmsPriceGrowth
    AveragedRelativePrices
    PriceDistorsion
    NablaPrice
    InflationFactor
    /* Wages */
    RealWageGrowthFactor
    AveragedRelativeWages
    OptimalRelativeRealWage
    H1
    H2
    H3
    EmploymentAgencyLagrangeMultiplier
    EmploymentAgencyLabourSupply
    NonOptimizingUnionsWageGrowth
    WageDistorsion
    NablaWage	    
    /* Monetary authority and Government */
    NominalInterestFactor
    OutputGap
    RealWageGrowthFactorGap
    PublicSpending
    /* Efficient variables (model without nominal rigidities) */    
    @#if (efficient_block==1)
      EfficientConsumption
      EfficientHouseholdLabourSupply
      EfficientHouseholdLagrangeMultiplier
      EfficientInvestment
      EfficientCapitalStock
      EfficientDepreciationRate
      dEfficientDepreciationRate
      EfficientInvestmentCost
      dEfficientInvestmentCost
      EfficientCapacityUtilizationFactor
      EfficientCapitalReturnRate
      EfficientHouseholdRealWage
      EfficientTobinQ
      EfficientRealInterestFactor
      EfficientLabourDemand
      EfficientRealMarginalCost
      EfficientGDP
      EfficientCapitalDemand
      EfficientRealGrossWage
    @#endif
    /* Shocks */
    @#for shock in 1:NumberOfShocks
      @{ExogenousVariables_vnames[shock]}
    @#endfor
    /* Observed variables */
    @#for vobs in 1:10
        @{ObservablesNames[vobs]}
    @#endfor
    RealInterestFactor
    UnderlyingInflationFactor
    DynamicWelfare
    CounterFactualConsumption
    ;

/* 15 Exogenous variables  */
varexo
    @#for shock in 1:NumberOfShocks
      @{ExogenousVariables_inames[shock]}
    @#endfor
    ;

parameters
       /*
       ** Household
       */
       sigmac $\sigma_c$
       sigmal $\sigma_l$
       eta $\eta$
       beta $\beta$
       investment_cost_size $\psi$
       capacity_utilization_factor_ss $\bar z$
       depreciation_rate_ss $\bar \delta$
       first_derivate_depreciation_rate_ss $\bar \delta''$	
       household_labour_supply_ss $\overline L$
       steady_state_investment_ratio $\frac{I}{Y}$
       /* 
       ** Prices
       */
       alpha $\alpha$
       thetaf $\theta_f$
       psif $\psi_f$
       xip $\xi_p$
       price_contract_length $\frac{1}{1-\xi_p}$
       gammap $\gamma_p$
       steady_state_mark_up_f $\mu_f$
       steady_state_labour_share $\frac{wL}{Y}$
       kimball_curvature_f $\epsilon_f$        
       /* 
       ** Wages 
       */
       psis $\psi_s$
       thetas $\theta_s$
       xiw $\xi_w$
       wage_contract_length $\frac{1}{1-\xi_w}$
       gammaw $\gamma_w$
       steady_state_mark_up_s $\mu_s$
       kimball_curvature_s $\epsilon_s$
       /* 
       ** Monetary authority 
       */
       @#if (efficient_block==0)
         ssGDP $\bar Y$
         ssRealWageGrowthFactor $\bar \varpi$
       @#endif
       steady_state_nominal_interest_factor $\bar R$
       steady_state_real_interest_factor $\bar r$
       nominal_interest_rate_smoothing $\rho_R$
       elasticity_of_nominal_interest_rate_to_inflation $r_{\pi}$
       elasticity_of_nominal_interest_rate_to_output_gap $r_y$
       elasticity_of_nominal_interest_rate_to_inflation_growth $r_{\Delta \pi}$
       elasticity_of_nominal_interest_rate_to_output_gap_growth $r_{\Delta y}$
       elasticity_of_nominal_interest_rate_to_real_wage_inflation $r_{w}$      
       volatile_components_share_in_HICP $\chi_{HICP}$
       /* 
       ** Parameters related to exogenous processes 
       */
       @#for shock in 1:NumberOfShocks
         @#if (ExogenousVariables_nblags[shock]>0)
           @#for lag in 1:ExogenousVariables_nblags[shock]
             @{ExogenousVariables_pnames[shock]}_ar@{lag} $\rho_{@{ExogenousVariables_vtexnames[shock]},@{lag}}$
             @{ExogenousVariables_pnames[shock]}_rho@{lag} $\rho_{@{ExogenousVariables_vtexnames[shock]}}(@{lag})$
           @#endfor
         @#endif
         @{ExogenousVariables_pnames[shock]}_i_std
         @{ExogenousVariables_pnames[shock]}_std $\sigma [@{ExogenousVariables_vtexnames[shock]}]$
         @{ExogenousVariables_pnames[shock]}_ss $ @{ExogenousVariables_sstexnames[shock]} $
       @#endfor
       /*
       ** Magic parameters
       */
       growthC
       growthI
       growthW
;      



/*
** Etalonnage des parametres
*/

beta   = 0.9979 ;
sigmac = 0.8400 ;
sigmal = 1.8200 ;
eta    = 0.5600 ;
price_contract_length = 4; // quarters
wage_contract_length = 4;  // quarters
gammap = 0.2900 ;
gammaw = 0.3000 ;
steady_state_investment_ratio = 0.2023;
steady_state_mark_up_f = 1.2000 ;
steady_state_mark_up_s = 1.2000 ;
steady_state_labour_share = 0.3849 ;
kimball_curvature_f = 10.3333;
kimball_curvature_s = 10.3333;
 

household_labour_supply_ss = 0.2715;

nominal_interest_rate_smoothing                            = 0.8400 ;
elasticity_of_nominal_interest_rate_to_inflation           = 1.5000 ;
elasticity_of_nominal_interest_rate_to_output_gap          = 0.1400 ;
elasticity_of_nominal_interest_rate_to_inflation_growth    = 0.0000 ;
elasticity_of_nominal_interest_rate_to_output_gap_growth   = 0.1700 ;
elasticity_of_nominal_interest_rate_to_real_wage_inflation = 0.0000 ;
steady_state_nominal_interest_factor                     = 1.0085 ;
volatile_components_share_in_HICP                        = 0.0;//0.1750 ;             

production_efficiency_growth_ss   = 0.0038 ;
production_efficiency_ss          = 1.0000 ;
inflation_target_ss               = 1.0053 ;
steady_state_real_interest_factor = steady_state_nominal_interest_factor / inflation_target_ss ;
consumption_tax_ss                = 1.1106 ;
income_tax_ss                     = 0.8814 ;
labour_income_tax_ss              = 0.8730 ;
investment_relative_price_ss      = 1.0000 ;
investment_efficiency_ss          = 1.0000 ;
risk_premium_ss                   = 1.0034 ;
labour_tax_ss                     = 1.2848 ;
taylor_ss                         = 1.0000 ;
public_spending_ss                = 0.2181;
wage_mark_up_ss                   = 1.0000 ;
price_mark_up_ss                  = 1.0000 ;
investment_cost_size              = 0.1000 ;
capacity_utilization_factor_ss    = 0.8213 ;
depreciation_rate_ss              = 0.0200 ;
volatile_prices_ss                = 1.053 ;

production_efficiency_growth_std   = 0.0035;
production_efficiency_std          = 0.005;
consumption_tax_std                = 0.0042;
labour_income_tax_std              = 0.0112;
income_tax_std                     = 0.0047;
labour_supply_std                  = 0.005;
investment_relative_price_std      = 0.0133;
investment_efficiency_std          = 0.005;
risk_premium_std                   = 0.005;
labour_tax_std                     = 0.0032;
price_mark_up_std                  = 0.005;
wage_mark_up_std                   = 0.005;
inflation_target_std               = 0.000; // 0.005;
taylor_std                         = 0.005;
public_spending_std                = 0.0212;
volatile_prices_std                = 0.010;

@#for shock in 1:NumberOfShocks
  @{ExogenousVariables_pnames[shock]}_i_std = 1.000 ; // Useless. Will be updated in the steady state file!     
  @#if (ExogenousVariables_nblags[shock]>0)
    @#for lag in 1:ExogenousVariables_nblags[shock]
      @{ExogenousVariables_pnames[shock]}_ar@{lag} = 0.0000 ; // Useless. Will be updated in the steady state file!
      @{ExogenousVariables_pnames[shock]}_rho@{lag} = @{ExogenousVariables_acorr1[shock]}^@{lag}; 
    @#endfor
  @#endif
@#endfor

growthC = -0.0232;
growthW =  -0.0660;
growthI = 0.1258;

model(use_dll);

	/*
	** HOUSEHOLDS.
	*/


	/* Equation:1:: Household Consumption FOC  */
	(Consumption - eta*Consumption(-1)/ProductionEfficiencyGrowth)^(-sigmac)
	*exp(LabourSupplyShock*(sigmac-1)/(1+sigmal)*(HouseholdLabourSupply/household_labour_supply_ss)^(1+sigmal))
	- ConsumptionTax*HouseholdLagrangeMultiplier ;

	/* Equation:2:: Household Euler equation  */
	beta*RiskPremium*NominalInterestFactor*ProductionEfficiencyGrowth(1)^(-sigmac)
	*HouseholdLagrangeMultiplier(1)*IncomeTax(1)/InflationFactor(1)
	- HouseholdLagrangeMultiplier*IncomeTax;
	
	/* Equation:3:: Household Labour FOC  */
	(Consumption - eta*Consumption(-1)/ProductionEfficiencyGrowth)^(1-sigmac)
	*(LabourSupplyShock/household_labour_supply_ss)
	*exp(LabourSupplyShock*(sigmac-1)/(1+sigmal)*(HouseholdLabourSupply/household_labour_supply_ss)^(1+sigmal))
	*(HouseholdLabourSupply/household_labour_supply_ss)^sigmal
	-HouseholdLagrangeMultiplier*IncomeTax*LabourIncomeTax*HouseholdRealWage;
 
	/* Equation:4:: Household Investment FOC  */
	TobinQ*(1-InvestmentCost-Investment/Investment(-1)*ProductionEfficiencyGrowth*dInvestmentCost)
	+beta*HouseholdLagrangeMultiplier(1)/HouseholdLagrangeMultiplier
	*ProductionEfficiencyGrowth(1)^(-sigmac)*TobinQ(1)*InvestmentEfficiencyShock(1)/InvestmentEfficiencyShock
	*(Investment(1)/Investment*ProductionEfficiencyGrowth(1))^2
	*dInvestmentCost(1)
	-InvestmentRelativePrice/InvestmentEfficiencyShock;

	/* Equation:5:: Depreciation rate */
	depreciation_rate_ss
	*exp((CapacityUtilizationFactor-capacity_utilization_factor_ss)*first_derivate_depreciation_rate_ss/depreciation_rate_ss)
	-DepreciationRate;

	/* Equation:6:: First derivate of the depreciation rate */
	first_derivate_depreciation_rate_ss
	*exp((CapacityUtilizationFactor-capacity_utilization_factor_ss)*first_derivate_depreciation_rate_ss/depreciation_rate_ss)
	-dDepreciationRate;

	/* Equation:7:: Household Capacity utilization rate */
	IncomeTax*CapitalReturnRate-TobinQ*dDepreciationRate;

	/* Equation:8:: Household Physical capital FOC */
	beta*HouseholdLagrangeMultiplier(1)/HouseholdLagrangeMultiplier
	*ProductionEfficiencyGrowth(1)^(-sigmac)
	*(TobinQ(1)*(1-DepreciationRate(1))+IncomeTax(1)*CapitalReturnRate(1)*CapacityUtilizationFactor(1))
	-TobinQ;

	/*Equation:9:: Physical capital stock law of motion */
	(1-DepreciationRate)*CapitalStock(-1)/ProductionEfficiencyGrowth
	+InvestmentEfficiencyShock*(1-InvestmentCost)*Investment-CapitalStock;

	/*Equation:10:: Investment cost */
        InvestmentCost = .5*investment_cost_size*(1+production_efficiency_growth_ss)*(1+production_efficiency_growth_ss)
        *(Investment/Investment(-1)*ProductionEfficiencyGrowth/(1+production_efficiency_growth_ss)-1)^2;

	/*Equation:11:: First derivate of the investment cost */
        dInvestmentCost = (Investment/Investment(-1)*ProductionEfficiencyGrowth/(1+production_efficiency_growth_ss)-1)
        *(1+production_efficiency_growth_ss)*investment_cost_size;


	/*
	** PRICES.
	*/


	/*Equation:12:: Price growth factor for non optimizing intermediate firms */
	 InflationTarget^(1-gammap)
	 *UnderlyingInflationFactor(-1)^gammap
	-NonOptimizingFirmsPriceGrowth;

	/*Equation:13:: Factor Price Frontier */
	LabourTax*RealGrossWage*LabourDemand/(CapitalReturnRate*CapitalDemand)
	- (1-alpha)/alpha;

	/*Equation:14:: Marginal cost */
	ProductionEfficiencyCycle^(alpha-1)
	*(CapitalReturnRate/alpha)^alpha
	*(LabourTax*RealGrossWage/(1-alpha))^(1-alpha)
	-RealMarginalCost;

	/*Equation:15:: Relative price of an optimizing intermediate firm */
	thetaf*(1+psif)/(thetaf*(1+psif)-1)*(Z1/Z2)
	+psif/(thetaf*(1+psif)-1)*OptimalRelativePrice^(1+(1+psif)*thetaf)*Z3/Z2
	-OptimalRelativePrice;

	/*Equation:16:: Lagrange multiplier associated to technological constraint of the final good representative firm */ 
	(1-xip)*OptimalRelativePrice^(1-thetaf*(1+psif))
	+xip*(NonOptimizingFirmsPriceGrowth/UnderlyingInflationFactor)^(1-thetaf*(1+psif))
	*FinalGoodLagrangeMultiplier(-1)^(1-thetaf*(1+psif))
	-FinalGoodLagrangeMultiplier^(1-thetaf*(1+psif));	
	
	/*Equation:17:: Z1 (relative price equation) */	
	HouseholdLagrangeMultiplier*RealMarginalCost*FinalGoodLagrangeMultiplier^(thetaf*(1+psif))*GDP
	+beta*xip*ProductionEfficiencyGrowth(1)^(1-sigmac)
	*(UnderlyingInflationFactor(1)/NonOptimizingFirmsPriceGrowth(1))^((1+psif)*thetaf)*Z1(1)
	-Z1;

	/*Equation:18:: Z2 (relative price equation) */	
	HouseholdLagrangeMultiplier*PriceMarkUpShock*FinalGoodLagrangeMultiplier^(thetaf*(1+psif))*GDP
	+beta*xip*ProductionEfficiencyGrowth(1)^(1-sigmac)
	*(UnderlyingInflationFactor(1)/NonOptimizingFirmsPriceGrowth(1))^((1+psif)*thetaf-1)*Z2(1)
	-Z2;

	/*Equation:19:: Z3 (relative price equation) */	
	HouseholdLagrangeMultiplier*PriceMarkUpShock*GDP
	+beta*xip*ProductionEfficiencyGrowth(1)^(1-sigmac)
	*NonOptimizingFirmsPriceGrowth(1)/UnderlyingInflationFactor(1)*Z3(1)
	-Z3;
	
	/*Equation:20:: Average of relative prices */
	(1-xip)*OptimalRelativePrice
	+xip*NonOptimizingFirmsPriceGrowth/UnderlyingInflationFactor*AveragedRelativePrices(-1)
	-AveragedRelativePrices;
	
	/*Equation:21:: Agregate price */
	psif*AveragedRelativePrices/(1+psif)
	+FinalGoodLagrangeMultiplier/(1+psif)
	-1;

	/*Equation:22:: Price Distorsion */
	psif/(1+psif)
	+NablaPrice/(1+psif)*FinalGoodLagrangeMultiplier^(thetaf*(1+psif))
	-PriceDistorsion;
	
	/*Equation:23:: nabla (recursive latent variable used in price distorsion equation) */
	(1-xip)*OptimalRelativePrice^(-(1+psif)*thetaf)
	+xip*NablaPrice(-1)*(NonOptimizingFirmsPriceGrowth/UnderlyingInflationFactor)^(-thetaf*(1+psif))
	-NablaPrice;


	/*
	** WAGES.
	*/


	/*Equation:24:: Wage growth factor of the non optimizing firms */
	InflationFactor(-1)^gammaw*InflationTarget^(1-gammaw)
	-NonOptimizingUnionsWageGrowth;

	/*Equation:25:: Real wage inflation factor */
	RealGrossWage/RealGrossWage(-1)-RealWageGrowthFactor;
	
	/*Equation:26:: Relative wage of an optimizing union */ 
	thetas*(1+psis)/(thetas*(1+psis)-1)*H1/H2
	+psis/(thetas*(1+psis)-1)*OptimalRelativeRealWage^(1+(1+psis)*thetas)*H3/H2
	-OptimalRelativeRealWage;

	/*Equation:27:: Lagrange multiplier associated to the employment agency */ 
	(1-xiw)*OptimalRelativeRealWage^(1-thetas*(1+psis))
	+xiw*(NonOptimizingUnionsWageGrowth/(RealWageGrowthFactor*InflationFactor))^(1-thetas*(1+psis))
	*EmploymentAgencyLagrangeMultiplier(-1)^(1-thetas*(1+psis))
	-EmploymentAgencyLagrangeMultiplier^(1-thetas*(1+psis));	


	/*Equation:28:: H1 (relative wage equation) */
	HouseholdLagrangeMultiplier*HouseholdRealWage*EmploymentAgencyLagrangeMultiplier^(thetas*(1+psis))*EmploymentAgencyLabourSupply
	+beta*xiw*ProductionEfficiencyGrowth(1)^(1-sigmac)
	*(RealWageGrowthFactor(1)*InflationFactor(1)/NonOptimizingUnionsWageGrowth(1))^((1+psis)*thetas)*H1(1)
	-H1;

	/*Equation:29:: H2 (relative wage equation) */
	HouseholdLagrangeMultiplier*WageMarkUpShock*RealGrossWage
	*EmploymentAgencyLagrangeMultiplier^(thetas*(1+psis))*EmploymentAgencyLabourSupply
	+beta*xiw*ProductionEfficiencyGrowth(1)^(1-sigmac)
	*(RealWageGrowthFactor(1)*InflationFactor(1)/NonOptimizingUnionsWageGrowth(1))^((1+psis)*thetas-1)*H2(1)
	-H2;

	/*Equation:30:: H3 (relative wage equation) */	
	HouseholdLagrangeMultiplier*WageMarkUpShock*RealGrossWage*EmploymentAgencyLabourSupply
	+beta*xiw*ProductionEfficiencyGrowth(1)^(1-sigmac)
	*NonOptimizingUnionsWageGrowth(1)/(InflationFactor(1)*RealWageGrowthFactor(1))*H3(1)
	-H3;

	/*Equation:31:: Average of relative wages */
	(1-xiw)*OptimalRelativeRealWage
	+xiw*NonOptimizingUnionsWageGrowth/(RealWageGrowthFactor*InflationFactor)*AveragedRelativeWages(-1)
	-AveragedRelativeWages;

	/*Equation:32:: Agregate Wage */
	psis*AveragedRelativeWages/(1+psis)
	+EmploymentAgencyLagrangeMultiplier/(1+psis)
	-1;

	/*Equation:33:: Wage Distorsion */
	psis/(1+psis)
	+NablaWage/(1+psis)*EmploymentAgencyLagrangeMultiplier^(thetas*(1+psis))
	-WageDistorsion;
	
	/*Equation:34:: nabla (recursive latent variable used in wage distorsion equation) */
	(1-xiw)*OptimalRelativeRealWage^(-(1+psis)*thetas)
	+xiw*NablaWage(-1)*(NonOptimizingUnionsWageGrowth/(RealWageGrowthFactor*InflationFactor))^(-thetas*(1+psis))
	-NablaWage;


	/*
	** MONETARY AUTHORITY & GOVERNMENT
	*/


	/*Equation:35:: Taylor rule */
	NominalInterestFactor(-1)^nominal_interest_rate_smoothing
	*(
	steady_state_nominal_interest_factor
	*(InflationFactor(-1)/inflation_target_ss)^elasticity_of_nominal_interest_rate_to_inflation
        //*(InflationFactor(1)/inflation_target_ss)^elasticity_of_nominal_interest_rate_to_inflation
	*OutputGap^elasticity_of_nominal_interest_rate_to_output_gap
	*(InflationFactor/InflationFactor(-1))^elasticity_of_nominal_interest_rate_to_inflation_growth
	*(OutputGap/OutputGap(-1))^elasticity_of_nominal_interest_rate_to_output_gap_growth
        *RealWageGrowthFactorGap^elasticity_of_nominal_interest_rate_to_real_wage_inflation
	)^(1-nominal_interest_rate_smoothing)
	*TaylorShock
	- NominalInterestFactor;

    /*Equation:35bis:: Definition of Underlying HICP Inflation */
    UnderlyingInflationFactor^(1-volatile_components_share_in_HICP)*FoodAndEnergyPrices^(volatile_components_share_in_HICP)
    -InflationFactor ;

	/*Equation:36:: Output gap */
	@#if (efficient_block==1)
	  GDP/EfficientGDP
	  -OutputGap;
          RealWageGrowthFactor/EfficientRealGrossWage*EfficientRealGrossWage(-1)
          -RealWageGrowthFactorGap;
	@#endif  
	@#if (efficient_block==0)
	  GDP/ssGDP
	  -OutputGap;
          RealWageGrowthFactor/
          -RealWageGrowthFactorGap;
	@#endif

	/*Equation:37:: Public Spending */
	PublicSpendingShare * GDP - PublicSpending;
	

	/*
	** MARKETS
	*/


	/*Equation:38:: Physical capital market equilibrium */
	CapacityUtilizationFactor*CapitalStock(-1)/ProductionEfficiencyGrowth - CapitalDemand ;

	/*Equation:39:: Relation between household labour supply and employment agency labour supply */
	HouseholdLabourSupply/WageDistorsion - EmploymentAgencyLabourSupply;

	/*Equation:40:: Labour market equilibrium */
	EmploymentAgencyLabourSupply - LabourDemand;

	/*Equation:41:: Relation between GDP and the sum of produced intermediate goods */
	CapitalDemand^alpha * (ProductionEfficiencyCycle*LabourDemand)^(1-alpha) / PriceDistorsion - GDP;

	/*Equation:42:: Final good market equilibrium */
	PublicSpending + Consumption + InvestmentRelativePrice*Investment
	- PriceMarkUpShock*GDP - (1-WageMarkUpShock)*RealGrossWage*LabourDemand;
	
	/* 
	** EQUATIONS FOR THE SHOCKS.
	*/

        @#for shock in 1:NumberOfShocks
          exp(@{ExogenousVariables_pnames[shock]}_i_std*@{ExogenousVariables_inames[shock]})      
          @#if (ExogenousVariables_nblags[shock]>0)
            @#for lag in 1:ExogenousVariables_nblags[shock]
              * @{ExogenousVariables_vnames[shock]}(-@{lag})^@{ExogenousVariables_pnames[shock]}_ar@{lag} 
            @#endfor
          @#endif
          @#if (shock==1)
            * (1+@{ExogenousVariables_pnames[shock]}_ss)^(1
          @#else
            * @{ExogenousVariables_pnames[shock]}_ss^(1
          @#endif
          @#if (ExogenousVariables_nblags[shock]>0)
            @#for lag in 1:ExogenousVariables_nblags[shock]
              - @{ExogenousVariables_pnames[shock]}_ar@{lag} 
            @#endfor
          @#endif
          ) - @{ExogenousVariables_vnames[shock]} ;
        @#endfor

	@#if (efficient_block==1)
	/*
	** EQUATIONS FOR THE EFFICIENT VARIABLES.
	*/
		
	
	/* Equation:58:: (Efficient) Household Consumption FOC */ 
	(EfficientConsumption - eta*EfficientConsumption(-1)/ProductionEfficiencyGrowth)^(-sigmac)
	*exp(LabourSupplyShock*(sigmac-1)/(1+sigmal)*(EfficientHouseholdLabourSupply/household_labour_supply_ss)^(1+sigmal))
	- ConsumptionTax*EfficientHouseholdLagrangeMultiplier ;

	/* Equation:59:: (Efficient) Household Euler equation  */
	beta*RiskPremium*EfficientRealInterestFactor*ProductionEfficiencyGrowth(1)^(-sigmac)
	*EfficientHouseholdLagrangeMultiplier(1)*IncomeTax(1)
	- EfficientHouseholdLagrangeMultiplier*IncomeTax;
	
	/* Equation:60:: (Efficient) Household Labour FOC  */
	(EfficientConsumption - eta*EfficientConsumption(-1)/ProductionEfficiencyGrowth)^(1-sigmac)
	*(LabourSupplyShock/household_labour_supply_ss)
	*exp(LabourSupplyShock*(sigmac-1)/(1+sigmal)*(EfficientHouseholdLabourSupply/household_labour_supply_ss)^(1+sigmal))
	*(EfficientHouseholdLabourSupply/household_labour_supply_ss)^sigmal
	-EfficientHouseholdLagrangeMultiplier*IncomeTax*LabourIncomeTax*EfficientHouseholdRealWage;
 
	/* Equation:61:: (Efficient) Household Investment FOC  */
	EfficientTobinQ*(1-EfficientInvestmentCost-EfficientInvestment/EfficientInvestment(-1)*ProductionEfficiencyGrowth*dEfficientInvestmentCost)
	+beta*EfficientHouseholdLagrangeMultiplier(1)/EfficientHouseholdLagrangeMultiplier
	*ProductionEfficiencyGrowth(1)^(-sigmac)*EfficientTobinQ(1)*InvestmentEfficiencyShock(1)/InvestmentEfficiencyShock
	*(EfficientInvestment(1)/EfficientInvestment*ProductionEfficiencyGrowth(1))^2
	*dEfficientInvestmentCost(1)-InvestmentRelativePrice/InvestmentEfficiencyShock;

	/* Equation:62:: (Efficient) Depreciation rate */
	depreciation_rate_ss
	*exp((EfficientCapacityUtilizationFactor-capacity_utilization_factor_ss)*first_derivate_depreciation_rate_ss/depreciation_rate_ss)
	-EfficientDepreciationRate;

	/* Equation:63:: (Efficient) First derivate of the depreciation rate */
	first_derivate_depreciation_rate_ss
	*exp((EfficientCapacityUtilizationFactor-capacity_utilization_factor_ss)*first_derivate_depreciation_rate_ss/depreciation_rate_ss)
	-dEfficientDepreciationRate;

	/* Equation:64:: (Efficient) Household Capacity utilization rate */
	IncomeTax*EfficientCapitalReturnRate-EfficientTobinQ*dEfficientDepreciationRate;

	/* Equation:65:: (Efficient) Household Physical capital FOC */
	beta*EfficientHouseholdLagrangeMultiplier(1)/EfficientHouseholdLagrangeMultiplier
	*ProductionEfficiencyGrowth(1)^(-sigmac)
	*(EfficientTobinQ(1)*(1-EfficientDepreciationRate(1))+IncomeTax(1)*EfficientCapitalReturnRate(1)*EfficientCapacityUtilizationFactor(1))
	-EfficientTobinQ;

	/*Equation:66:: (Efficient) Physical capital stock law of motion */
	(1-EfficientDepreciationRate)*EfficientCapitalStock(-1)/ProductionEfficiencyGrowth
	+InvestmentEfficiencyShock*(1-EfficientInvestmentCost)*EfficientInvestment
	-EfficientCapitalStock;

	/*Equation:67:: (Efficient) Factor Price Frontier */
	LabourTax*EfficientRealGrossWage*EfficientLabourDemand/(EfficientCapitalReturnRate*EfficientCapitalDemand)
	- (1-alpha)/alpha;

	/*Equation:68:: (Efficient) Marginal cost */
	ProductionEfficiencyCycle^(alpha-1)
	*(EfficientCapitalReturnRate/alpha)^alpha
	*(LabourTax*EfficientRealGrossWage/(1-alpha))^(1-alpha)
	-EfficientRealMarginalCost;

	/*Equation:69:: (Efficient) Price decision */
	thetaf*(1+psif)/(thetaf*(1+psif)-1)*EfficientRealMarginalCost
	+psif/(thetaf*(1+psif)-1)
	-1;

	/*Equation:70:: (Efficient) Wage decision */ 
	thetas*(1+psis)/(thetas*(1+psis)-1)*EfficientHouseholdRealWage/EfficientRealGrossWage
	+psis/(thetas*(1+psis)-1)
	-1;

	/*Equation:71:: (Efficient) Labour market equilibrium */
	EfficientLabourDemand - EfficientHouseholdLabourSupply;

	/*Equation:72:: (Efficient) Physical capital market equilibrium */
	EfficientCapacityUtilizationFactor*EfficientCapitalStock(-1)/ProductionEfficiencyGrowth - EfficientCapitalDemand ;	

	/*Equation:73:: (Efficient) Final good market equilibrium */
	EfficientConsumption + InvestmentRelativePrice*EfficientInvestment 
	- (1-PublicSpendingShare)*EfficientGDP;

	/*Equation:74:: (Efficient) Relation between GDP and the sum of produced intermediate goods */
	EfficientCapitalDemand^alpha * (ProductionEfficiencyCycle*EfficientLabourDemand)^(1-alpha) - EfficientGDP;

        /*Equation:75:: (Efficient) Investment cost */
        EfficientInvestmentCost = .5*investment_cost_size*(1+production_efficiency_growth_ss)*(1+production_efficiency_growth_ss)
        *(EfficientInvestment/EfficientInvestment(-1)*ProductionEfficiencyGrowth/(1+production_efficiency_growth_ss)-1)^2;

        /*Equation:76:: (Efficient) First derivate of the investment cost */
        dEfficientInvestmentCost = (EfficientInvestment/EfficientInvestment(-1)*ProductionEfficiencyGrowth/(1+production_efficiency_growth_ss)-1)
        *(1+production_efficiency_growth_ss)*investment_cost_size;

	@#endif

	/*
	** MEASUREMENT EQUATIONS.
	*/

	dY = 100*log(GDP/GDP(-1)*ProductionEfficiencyGrowth) ;
	dC = 100*log(Consumption/Consumption(-1)*ProductionEfficiencyGrowth) + growthC ;
	dI = 100*log(Investment/Investment(-1)*ProductionEfficiencyGrowth) + growthI ;
	dW = 100*log(RealGrossWage*LabourDemand/RealGrossWage(-1)/LabourDemand(-1)*ProductionEfficiencyGrowth) + growthW ; 
	LoggedPI = 100*log(InflationFactor);
	LoggedR  = 100*log(NominalInterestFactor);
	TUC  = 100*CapacityUtilizationFactor;
        Lobs =  LabourDemand+LabourDemand(-1)+LabourDemand(-2)+LabourDemand(-3);
	dG = 100*log(PublicSpending/PublicSpending(-1)*ProductionEfficiencyGrowth);
        HICP_GA = LoggedPI + LoggedPI(-1) + LoggedPI(-2) + LoggedPI(-3);
        RealInterestFactor = NominalInterestFactor/InflationFactor(1);

        /*
        ** Welfare evaluation.
        */

        DynamicWelfare = @{UtilityFlow} + beta*DynamicWelfare(1)*ProductionEfficiencyGrowth(1)^(1-sigmac);
        (1-beta*(1+production_efficiency_growth_ss)^(1-sigmac))*DynamicWelfare = @{CounterFactualUtilityFlow} ;    


end;


/* Calibration of the variance of the shock  */
shocks;
    @#for shock in 1:NumberOfShocks
        var @{ExogenousVariables_inames[shock]} = 1.0000 ;
    @#endfor
end;


varobs
    @#for vobs in 1:number_of_observables
        @{ObservablesNames[vobs]}
    @#endfor
;

overall_prior_tightness = 1;

estimated_params;
/*
$$
$$ Size of the shocks.
$$
*/

production_efficiency_growth_std, inv_gamma1_pdf, mode_and_variance_to_mean(0.0035,Inf,3), Inf ;
production_efficiency_std,        inv_gamma1_pdf, mode_and_variance_to_mean(0.01,Inf,3), Inf ;
consumption_tax_std,              inv_gamma1_pdf, mode_and_variance_to_mean(0.0042,Inf,3), Inf ;
labour_income_tax_std,            inv_gamma1_pdf, mode_and_variance_to_mean(0.0112,Inf,3), Inf ;
income_tax_std,                   inv_gamma1_pdf, mode_and_variance_to_mean(0.0047,Inf,3), Inf ;
labour_supply_std,                inv_gamma1_pdf, mode_and_variance_to_mean(0.01,Inf,3), Inf ;
investment_relative_price_std,    inv_gamma1_pdf, mode_and_variance_to_mean(0.005,Inf,3), Inf ;
investment_efficiency_std,        inv_gamma1_pdf, mode_and_variance_to_mean(0.01,Inf,3), Inf ;
risk_premium_std,                 inv_gamma1_pdf, mode_and_variance_to_mean(0.01,Inf,3), Inf ;
labour_tax_std,                   inv_gamma1_pdf, mode_and_variance_to_mean(0.0032,Inf,3), Inf ;
price_mark_up_std,                inv_gamma1_pdf, mode_and_variance_to_mean(0.005,Inf,3), Inf ;
wage_mark_up_std,                 inv_gamma1_pdf, mode_and_variance_to_mean(0.005,Inf,3), Inf ;
taylor_std,                       inv_gamma1_pdf, mode_and_variance_to_mean(0.005,Inf,3), Inf ;
public_spending_std,              inv_gamma1_pdf, mode_and_variance_to_mean(0.0212,Inf,3), Inf ;
//volatile_prices_std,              inv_gamma1_pdf, mode_and_variance_to_mean(0.01,Inf,3), Inf ;



/*
$$
$$ Deep parameters.
$$
*/

sigmac,                                   normal_pdf, 1.2, .05000*overall_prior_tightness ;
sigmal,                                   normal_pdf, 2, .3000*overall_prior_tightness ;
eta,                                      beta_pdf, mode_and_variance_to_mean(.5600,(.14000*overall_prior_tightness)^2,4), .14000*overall_prior_tightness ;
price_contract_length,                    gamma_pdf, mode_and_variance_to_mean(4.0000,(1.0000*overall_prior_tightness)^2,1,1), 1.0000*overall_prior_tightness, 1; 
wage_contract_length,                     gamma_pdf, mode_and_variance_to_mean(4.0000,(1.0000*overall_prior_tightness)^2,1,1), 1.0000*overall_prior_tightness, 1;
steady_state_mark_up_f,                   gamma_pdf, mode_and_variance_to_mean(1.2000,(0.05000*overall_prior_tightness)^2,1,1), 0.05000*overall_prior_tightness, 1;
steady_state_mark_up_s,                   gamma_pdf, mode_and_variance_to_mean(1.2000,(0.2000*overall_prior_tightness)^2,1,1), 0.2000*overall_prior_tightness, 1;
gammap, beta_pdf,                         mode_and_variance_to_mean(.2900,(.1000*overall_prior_tightness)^2,4),  .1000*overall_prior_tightness ;
gammaw, beta_pdf,                         mode_and_variance_to_mean(.3000,(.1000*overall_prior_tightness)^2,4),  .1000*overall_prior_tightness ;
kimball_curvature_f,                      gamma_pdf, mode_and_variance_to_mean(10.0000,(2.0*overall_prior_tightness)^2,1,1), 2.0*overall_prior_tightness, 1;
kimball_curvature_s,                      gamma_pdf, mode_and_variance_to_mean(10.0000,(2.0*overall_prior_tightness)^2,1,1), 2.0*overall_prior_tightness, 1;
steady_state_labour_share,                beta_pdf, mode_and_variance_to_mean(.3910,(.00300*overall_prior_tightness)^2,4,0,1), .00300*overall_prior_tightness ;
depreciation_rate_ss,                     beta_pdf, mode_and_variance_to_mean(.0200,(.0500*overall_prior_tightness)^2,4), .0500*overall_prior_tightness ;
nominal_interest_rate_smoothing,          beta_pdf, mode_and_variance_to_mean(.8300,(.05000*overall_prior_tightness)^2,4), .05000*overall_prior_tightness ;
elasticity_of_nominal_interest_rate_to_inflation,           normal_pdf, 1.800*(1-0.175), .0800*overall_prior_tightness ;
elasticity_of_nominal_interest_rate_to_output_gap,          normal_pdf, .3500, .05000*overall_prior_tightness ;
elasticity_of_nominal_interest_rate_to_inflation_growth,    normal_pdf, .0000, .5000*overall_prior_tightness ;
elasticity_of_nominal_interest_rate_to_output_gap_growth,   normal_pdf, .7000, .3000*overall_prior_tightness ;
elasticity_of_nominal_interest_rate_to_real_wage_inflation, normal_pdf, .0000, .5000*overall_prior_tightness ;
//volatile_components_share_in_HICP,        beta_pdf, mode_and_variance_to_mean(.1750,(.1000*overall_prior_tightness)^2,4), .1000*overall_prior_tightness ;

/*
$$
$$ Steady state related parameters.
$$
*/

production_efficiency_growth_ss,      beta_pdf, mode_and_variance_to_mean(0.0042,(0.0020*overall_prior_tightness)^2,4,0,0.02), .0020*overall_prior_tightness, 0.0000, 0.0200 ;
inflation_target_ss,                  beta_pdf, mode_and_variance_to_mean(1.0053,(0.0040*overall_prior_tightness)^2,4,1,1.02), .0040*overall_prior_tightness, 1.0000, 1.0200 ;
consumption_tax_ss,                   beta_pdf, mode_and_variance_to_mean(1.1106,(.0500*overall_prior_tightness)^2,4,1,2), .0500*overall_prior_tightness, 1, 2;
income_tax_ss,                        beta_pdf, mode_and_variance_to_mean(.8814,(.0500*overall_prior_tightness)^2,4), .0500*overall_prior_tightness;
labour_income_tax_ss,                 beta_pdf, mode_and_variance_to_mean(.8771,(.0500*overall_prior_tightness)^2,4), .0500*overall_prior_tightness;
labour_tax_ss,                        beta_pdf, mode_and_variance_to_mean(1.2848,(.020*overall_prior_tightness)^2,4,1,2), .020*overall_prior_tightness, 1, 2;
public_spending_ss,                   beta_pdf, mode_and_variance_to_mean(0.2174,(.0400*overall_prior_tightness)^2,4), .04000*overall_prior_tightness ;
investment_cost_size,                 gamma_pdf, mode_and_variance_to_mean(2.000,(.5000*overall_prior_tightness)^2,1), .5000*overall_prior_tightness ;
capacity_utilization_factor_ss,       normal_pdf, 0.8214, 0.05*overall_prior_tightness ;
household_labour_supply_ss,           normal_pdf, 0.2710, 0.1*overall_prior_tightness ;
steady_state_real_interest_factor,    beta_pdf, mode_and_variance_to_mean(1.0085/1.0053,(0.0020*overall_prior_tightness)^2,4,1,1.02), .0020*overall_prior_tightness, 1.0000, 1.0200 ;

/*
$$
$$ Parameters related to the exogenous variables
$$
*/

@#for shock in [1,2,3,4,5,6,7,8,9,10,11,12,14,15,16]
  @#if (ExogenousVariables_nblags[shock]>0)
    @#for lag in 1:ExogenousVariables_nblags[shock]
            @{ExogenousVariables_pnames[shock]}_rho@{lag}, beta_pdf, mode_and_variance_to_mean(@{ExogenousVariables_acorr1[shock]}^@{lag},.05*(1/@{lag})^@{ar_variance_decrease},4,0,1), sqrt(.05*(1/@{lag})^@{ar_variance_decrease}),0,1;
            //@{ExogenousVariables_pnames[shock]}_rho@{lag}, beta_pdf, mode_and_variance_to_mean(0.5,.05*(1/@{lag})^@{ar_variance_decrease},4,-1,1), sqrt(.05*(1/@{lag})^@{ar_variance_decrease}),-1, 1;
    @#endfor
  @#endif
@#endfor

/*
$$
$$ Deterministic cointegration gap parameters
$$
*/

growthC, normal_pdf,-0.0490,0.02;
growthI, normal_pdf,0.1768,0.02;
growthW, normal_pdf,-0.1214,0.02;

end;

options_.prior_trunc = 0;
options_.plot_priors = 0;

maxNumCompThreads(2);
estimation(datafile='MakeData',mh_replic=0);//mode_file=mze_mode,

//nominal_interest_rate_smoothing = 0;
//elasticity_of_nominal_interest_rate_to_inflation = 0 ;
//elasticity_of_nominal_interest_rate_to_output_gap = 0 ;
//elasticity_of_nominal_interest_rate_to_inflation_growth = 0 ;
//elasticity_of_nominal_interest_rate_to_output_gap_growth = 0 ;
//elasticity_of_nominal_interest_rate_to_real_wage_inflation = 0;
stoch_simul(order=2,irf=0,nomoments) DynamicWelfare Investment Consumption CapitalStock; 
